100 REMark SUPERCHARGE Demonstration 1.0
105 REMark  1985 Simon N Goodwin
110 MODE 4:OPEN #3,con_424x148a57x15
115 PAPER #3,210:CLS #3:WINDOW #3,425,148,48,10
120 INK #3,7:PAPER #3,0:CLS #3
125 CSIZE #3,1,0:BORDER #3,2,2:BORDER #3,4,128:AT #3,1,3
130 CSIZE #3,2,1:PRINT #3,"Digital Precision SUPERCHARGE"
135 CSIZE #3,2,0:AT #3,4,5
140 PRINT #3;"DEMONSTRATION ROUTINES:"
145 INK #3,0:PAPER #3,4
150 AT #3,7,5:PRINT #3,"F1 FAST DATA-PROCESSING"
155 AT #3,9,5:PRINT #3,"F2 FAST GRAPHICS       "
160 INK #3,7:PAPER #3,0
165 AT #3,12,5:PRINT #3,"PLEASE ENTER     OR"
170 INK #3,0:PAPER #3,7
175 AT #3,12,18:PRINT #3,"F1 ":AT #3,12,25:PRINT #3,"F2 "
180 CLOSE #3
185 REPeat poll
190   IF KEYROW(0)=2 THEN NUMBER_CRUNCH:RUN
195   IF KEYROW(0)=8 THEN GRAPHIX:RUN
200 END REPeat poll
205 DEFine PROCedure GRAPHIX
210 REMark 
215 REMark GRAPHICS DEMONSTRATION
220 REMark 
225 REMark Run this in SuperBASIC, then compile it. The compiled version
230 REMark is much faster, even though it supports all of the complex
235 REMark 'options' allowed by the interpreter: WINDOWS, STIPPLES,
240 REMark CTRL-F5, OVER, MODE and so on...
245 REMark Hold down the escape key to stop the demonstration.
250 REMark 
255 REMark You can EXEC several copies of this demo at once. If each
260 REMark copy has a different priority the effect is fascinating...
265 REMark 
270 PRINT "Thinking..."
275 OPEN #3,scr_512x256a0x0
280 DIM xpos%(100),ypos%(100)
285 FOR i=0 TO 100
290   xpos%(i)=SIN(i*PI/50)*220+250
295   ypos%(i)=COS(i*PI/25)*COS(i*PI/50)*110+120
300 END FOR i
305 CLS #3
310 OVER #3,-1
315 REPeat forever
320 x%=0
325 REPeat movedown
330   BLOCK #3,10,10,xpos%(x%),ypos%(x%),7
335   IF x%=100 THEN EXIT movedown
340   x%=x%+1
345 END REPeat movedown
350 x%=100
355 REPeat moveup
360   BLOCK #3,8,8,xpos%(x%),ypos%(x%),4
365   IF x%=0 THEN EXIT moveup
370   x%=x%-1
375 END REPeat moveup
380 IF KEYROW(1)=8 THEN RETurn 
385 END REPeat forever
390 END DEFine GRAPHIX
395 REMark 
400 REMark This routine finds a specified number of prime numbers.
405 REMark It forms the basis of many nmmber-crunching applications
410 REMark of computers in statistics and cryptography, etc...
415 REMark  1985 Freddy A Vachha
420 REMark 
425 DEFine PROCedure NUMBER_CRUNCH
430 CLS
435 REPeat get_limit
440   INPUT "Enter number of primes to be found: ";LIMIT%
445   IF LIMIT%<40 OR LIMIT%>300 THEN 
450     PRINT "Be reasonable! Choose a value between 40 and 300."
455   ELSE 
460     EXIT get_limit
465   END IF 
470 END REPeat get_limit
475 DIM ARRAY%(LIMIT%)
480 PRINT "Thinking... ";
485 START_TIME=DATE
490 ARRAY%(1)=2
495 ARRAY%(2)=3
500 ARRAY%(3)=5
505 INDEX%=3
510 TEST%=5
515 INCREMENT%=2
517 REMark +
520 REPeat find_prime
525   REMark TEST% is the number whose primeness is being checked
530   REPeat try_prime
535     TEST%=TEST%+INCREMENT%
540     INCREMENT%=6-INCREMENT%
545     REMark INCREMENT% oscillates from 2 to 4
550     COUNTER%=2
555     REMark COUNTER% is the index of the prime divisor being checked
560     REPeat try
565       COUNTER%=COUNTER%+1
570       DIVISOR%=ARRAY%(COUNTER%)
575       IF DIVISOR%*DIVISOR%>TEST% THEN EXIT try_prime
580       REMark We only need to check values up to the square root of TEST%
585       TMP%=TEST%/DIVISOR%
590       IF TEST%=TMP%*DIVISOR% THEN EXIT try
595     END REPeat try
600   REMark Try another
605   END REPeat try_prime
607   REMark -
610   REMark We've found a new prime
615   INDEX%=INDEX%+1
620   ARRAY%(INDEX%)=TEST%
625   REMark AND FILL IT IN....
630   IF INDEX%=LIMIT% THEN EXIT find_prime
635 END REPeat find_prime
640 REMark We want only the first LIMIT% primes
645 PRINT LIMIT%;" primes found in ";DATE-START_TIME;" seconds."
650 PRINT "Here they are:-"
655 Z%=0
660 REPeat print_primes
665   Z%=Z%+1
670   PRINT !ARRAY%(Z%)!
675   IF Z%=LIMIT% THEN EXIT print_primes
680 END REPeat print_primes
685 PRINT #0;"Press SPACE"
690 REPeat poll:IF KEYROW(1) THEN EXIT poll
695 END DEFine NUMBER_CRUNCH
